diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-tx-buffer.cc ns-3.31/src/internet/model/tcp-tx-buffer.cc
--- ns-3.30.1/src/internet/model/tcp-tx-buffer.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-tx-buffer.cc	2020-06-27 17:38:30.000000000 -0700
@@ -32,47 +32,9 @@
 namespace ns3 {
 
 NS_LOG_COMPONENT_DEFINE ("TcpTxBuffer");
-
-void
-TcpTxItem::Print (std::ostream &os) const
-{
-  bool comma = false;
-  os << "[" << m_startSeq << ";" << m_startSeq + GetSeqSize () << "|"
-     << GetSeqSize () << "]";
-
-  if (m_lost)
-    {
-      os << "[lost]";
-      comma = true;
-    }
-  if (m_retrans)
-    {
-      if (comma)
-        {
-          os << ",";
-        }
-
-      os << "[retrans]";
-      comma = true;
-    }
-  if (m_sacked)
-    {
-      if (comma)
-        {
-          os << ",";
-        }
-      os << "[sacked]";
-      comma = true;
-    }
-  if (comma)
-    {
-      os << ",";
-    }
-  os << "[" << m_lastSent.GetSeconds () << "]";
-}
-
 NS_OBJECT_ENSURE_REGISTERED (TcpTxBuffer);
 
+Callback<void, TcpTxItem *> TcpTxBuffer::m_nullCb = MakeNullCallback<void, TcpTxItem*> ();
 TypeId
 TcpTxBuffer::GetTypeId (void)
 {
@@ -98,6 +60,7 @@
 TcpTxBuffer::TcpTxBuffer (uint32_t n)
   : m_maxBuffer (32768), m_size (0), m_sentSize (0), m_firstByteSeq (n)
 {
+  m_rWndCallback = MakeNullCallback<uint32_t> ();
 }
 
 TcpTxBuffer::~TcpTxBuffer (void)
@@ -156,6 +119,36 @@
 }
 
 void
+TcpTxBuffer::SetDupAckThresh (uint32_t dupAckThresh)
+{
+  m_dupAckThresh = dupAckThresh;
+}
+
+void
+TcpTxBuffer::SetSegmentSize (uint32_t segmentSize)
+{
+  m_segmentSize = segmentSize;
+}
+
+uint32_t
+TcpTxBuffer::GetRetransmitsCount (void) const
+{
+  return m_retrans;
+}
+
+uint32_t
+TcpTxBuffer::GetLost (void) const
+{
+  return m_lostOut;
+}
+
+uint32_t
+TcpTxBuffer::GetSacked (void) const
+{
+  return m_sackedOut;
+}
+
+void
 TcpTxBuffer::SetHeadSequence (const SequenceNumber32& seq)
 {
   NS_LOG_FUNCTION (this << seq);
@@ -212,7 +205,7 @@
   return 0;
 }
 
-Ptr<Packet>
+TcpTxItem *
 TcpTxBuffer::CopyFromSequence (uint32_t numBytes, const SequenceNumber32& seq)
 {
   NS_LOG_FUNCTION (this << numBytes << seq);
@@ -226,7 +219,7 @@
 
   if (s == 0)
     {
-      return Create<Packet> ();
+      return nullptr;
     }
 
   TcpTxItem *outItem = nullptr;
@@ -265,14 +258,11 @@
     }
 
   outItem->m_lastSent = Simulator::Now ();
-  Ptr<Packet> toRet = outItem->m_packet->Copy ();
-
-  NS_ASSERT (toRet->GetSize () <= s);
   NS_ASSERT_MSG (outItem->m_startSeq >= m_firstByteSeq,
                  "Returning an item " << *outItem << " with SND.UNA as " <<
                  m_firstByteSeq);
   ConsistencyCheck ();
-  return toRet;
+  return outItem;
 }
 
 TcpTxItem*
@@ -599,7 +589,7 @@
 
   // If one is retrans and the other is not, cancel the retransmitted flag.
   // We are merging this segment for the retransmit, so the count will
-  // be updated in GetTransmittedSegment.
+  // be updated in MarkTransmittedSegment.
   if (! AreEquals (t1->m_retrans, t2->m_retrans))
     {
       if (t1->m_retrans)
@@ -649,7 +639,8 @@
     }
 }
 void
-TcpTxBuffer::DiscardUpTo (const SequenceNumber32& seq)
+TcpTxBuffer::DiscardUpTo (const SequenceNumber32& seq,
+                          const Callback<void, TcpTxItem *> &beforeDelCb)
 {
   NS_LOG_FUNCTION (this << seq);
 
@@ -671,7 +662,7 @@
       if (i == m_sentList.end ())
         {
           // Move data from app list to sent list, so we can delete the item
-          Ptr<Packet> p = CopyFromSequence (offset, m_firstByteSeq);
+          Ptr<Packet> p = CopyFromSequence (offset, m_firstByteSeq)->GetPacketCopy ();
           NS_ASSERT (p != nullptr);
           NS_UNUSED (p);
           i = m_sentList.begin ();
@@ -697,6 +688,13 @@
           NS_LOG_INFO ("Removed " << *item << " lost: " << m_lostOut <<
                        " retrans: " << m_retrans << " sacked: " << m_sackedOut <<
                        ". Remaining data " << m_size);
+
+          if (!beforeDelCb.IsNull ())
+            {
+              // Inform Rate algorithms only when a full packet is ACKed
+              beforeDelCb (item);
+            }
+
           delete item;
         }
       else if (offset > 0)
@@ -758,23 +756,24 @@
   ConsistencyCheck ();
 }
 
-bool
-TcpTxBuffer::Update (const TcpOptionSack::SackList &list)
+uint32_t
+TcpTxBuffer::Update (const TcpOptionSack::SackList &list,
+                     const Callback<void, TcpTxItem *> &sackedCb)
 {
   NS_LOG_FUNCTION (this);
   NS_LOG_INFO ("Updating scoreboard, got " << list.size () << " blocks to analyze");
 
-  bool modified = false;
+  uint32_t bytesSacked = 0;
 
   for (auto option_it = list.begin (); option_it != list.end (); ++option_it)
     {
       PacketList::iterator item_it = m_sentList.begin ();
       SequenceNumber32 beginOfCurrentPacket = m_firstByteSeq;
 
-      if (m_firstByteSeq + m_sentSize < (*option_it).first && !modified)
+      if (m_firstByteSeq + m_sentSize < (*option_it).first)
         {
           NS_LOG_INFO ("Not updating scoreboard, the option block is outside the sent list");
-          return false;
+          return bytesSacked;
         }
 
       while (item_it != m_sentList.end ())
@@ -806,6 +805,7 @@
 
                   (*item_it)->m_sacked = true;
                   m_sackedOut += (*item_it)->m_packet->GetSize ();
+                  bytesSacked += (*item_it)->m_packet->GetSize ();
 
                   if (m_highestSack.first == m_sentList.end()
                       || m_highestSack.second <= beginOfCurrentPacket + pktSize)
@@ -817,8 +817,12 @@
                                ", checking sentList for block " << *(*item_it) <<
                                ", found in the sackboard, sacking, current highSack: " <<
                                m_highestSack.second);
+
+                  if (!sackedCb.IsNull ())
+                    {
+                      sackedCb (*item_it);
+                    }
                 }
-              modified = true;
             }
           else if (beginOfCurrentPacket + pktSize > (*option_it).second)
             {
@@ -834,9 +838,9 @@
         }
     }
 
-  if (modified)
+  if (bytesSacked > 0)
     {
-      NS_ASSERT_MSG (modified && m_highestSack.first != m_sentList.end(), "Buffer status: " << *this);
+      NS_ASSERT_MSG (m_highestSack.first != m_sentList.end(), "Buffer status: " << *this);
       UpdateLostCount ();
     }
 
@@ -845,7 +849,7 @@
   //NS_ASSERT (list.size () == 0 || modified);   // Assert for duplicated SACK or
                                                  // impossiblity to map the option into the sent blocks
   ConsistencyCheck ();
-  return modified;
+  return bytesSacked;
 }
 
 void
@@ -937,9 +941,9 @@
 }
 
 bool
-TcpTxBuffer::NextSeg (SequenceNumber32 *seq, bool isRecovery) const
+TcpTxBuffer::NextSeg (SequenceNumber32 *seq, SequenceNumber32 *seqHigh, bool isRecovery) const
 {
-  NS_LOG_FUNCTION (this);
+  NS_LOG_FUNCTION (this << isRecovery);
   /* RFC 6675, NextSeg definition.
    *
    * (1) If there exists a smallest unSACKed sequence number 'S2' that
@@ -971,6 +975,7 @@
             {
               NS_LOG_INFO("IsLost, returning" << beginOfCurrentPkt);
               *seq = beginOfCurrentPkt;
+              *seqHigh = *seq + m_segmentSize;
               return true;
             }
           else if (seqPerRule3.GetValue () == 0 && isRecovery)
@@ -993,9 +998,18 @@
    */
   if (SizeFromSequence (m_firstByteSeq + m_sentSize) > 0)
     {
-      NS_LOG_INFO ("There is unsent data. Send it");
-      *seq = m_firstByteSeq + m_sentSize;
-      return true;
+      if (m_sentSize <= m_rWndCallback ())
+        {
+          NS_LOG_INFO ("There is unsent data. Send it");
+          *seq = m_firstByteSeq + m_sentSize;
+          *seqHigh = *seq + std::min<uint32_t> (m_segmentSize, (m_rWndCallback () - m_sentSize));
+          return true;
+        }
+      else
+        {
+          NS_LOG_INFO ("There is no available receiver window to send");
+          return false;
+        }
     }
   else
     {
@@ -1012,6 +1026,7 @@
     {
       NS_LOG_INFO ("Rule3 valid. " << seqPerRule3);
       *seq = seqPerRule3;
+      *seqHigh = *seq + m_segmentSize;
       return true;
     }
 
@@ -1189,6 +1204,13 @@
 }
 
 void
+TcpTxBuffer::SetRWndCallback (Callback<uint32_t> rWndCallback)
+{
+  NS_LOG_FUNCTION (this);
+  m_rWndCallback = rWndCallback;
+}
+
+void
 TcpTxBuffer::ResetSentList ()
 {
   NS_LOG_FUNCTION (this);
@@ -1423,10 +1445,10 @@
   SequenceNumber32 beginOfCurrentPacket = tcpTxBuf.m_firstByteSeq;
   uint32_t sentSize = 0, appSize = 0;
 
-  Ptr<Packet> p;
+  Ptr<const Packet> p;
   for (it = tcpTxBuf.m_sentList.begin (); it != tcpTxBuf.m_sentList.end (); ++it)
     {
-      p = (*it)->m_packet;
+      p = (*it)->GetPacket ();
       ss << "{";
       (*it)->Print (ss);
       ss << "}";
@@ -1436,7 +1458,7 @@
 
   for (it = tcpTxBuf.m_appList.begin (); it != tcpTxBuf.m_appList.end (); ++it)
     {
-      appSize += (*it)->m_packet->GetSize ();
+      appSize += (*it)->GetPacket ()->GetSize ();
     }
 
   os << "Sent list: " << ss.str () << ", size = " << tcpTxBuf.m_sentList.size () <<
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-tx-buffer.h ns-3.31/src/internet/model/tcp-tx-buffer.h
--- ns-3.30.1/src/internet/model/tcp-tx-buffer.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-tx-buffer.h	2020-06-27 17:38:30.000000000 -0700
@@ -25,9 +25,8 @@
 #include "ns3/object.h"
 #include "ns3/traced-value.h"
 #include "ns3/sequence-number.h"
-#include "ns3/nstime.h"
 #include "ns3/tcp-option-sack.h"
-#include "ns3/packet.h"
+#include "ns3/tcp-tx-item.h"
 
 namespace ns3 {
 class Packet;
@@ -35,37 +34,6 @@
 /**
  * \ingroup tcp
  *
- * \brief Item that encloses the application packet and some flags for it
- */
-class TcpTxItem
-{
-public:
-  // Default constructor, copy-constructor, destructor
-
-  /**
-   * \brief Print the time
-   * \param os ostream
-   */
-  void Print (std::ostream &os) const;
-
-  /**
-   * \brief Get the size in the sequence number space
-   *
-   * \return 1 if the packet size is 0 or there's no packet, otherwise the size of the packet
-   */
-  uint32_t GetSeqSize (void) const { return m_packet && m_packet->GetSize () > 0 ? m_packet->GetSize () : 1; }
-
-  SequenceNumber32 m_startSeq {0};     //!< Sequence number of the item (if transmitted)
-  Ptr<Packet> m_packet {nullptr};    //!< Application packet (can be null)
-  bool m_lost          {false};      //!< Indicates if the segment has been lost (RTO)
-  bool m_retrans       {false};      //!< Indicates if the segment is retransmitted
-  Time m_lastSent      {Time::Min()};//!< Timestamp of the time at which the segment has been sent last time
-  bool m_sacked        {false};      //!< Indicates if the segment has been SACKed
-};
-
-/**
- * \ingroup tcp
- *
  * \brief Tcp sender buffer
  *
  * The class keeps track of all data that the application wishes to transmit to
@@ -208,13 +176,13 @@
    * \brief Set the DupAckThresh
    * \param dupAckThresh the threshold
    */
-  void SetDupAckThresh (uint32_t dupAckThresh) { m_dupAckThresh = dupAckThresh; }
+  void SetDupAckThresh (uint32_t dupAckThresh);
 
   /**
    * \brief Set the segment size
    * \param segmentSize the segment size
    */
-  void SetSegmentSize (uint32_t segmentSize) { m_segmentSize = segmentSize; }
+  void SetSegmentSize (uint32_t segmentSize);
 
   /**
    * \brief Return the number of segments in the sent list that
@@ -225,7 +193,7 @@
    *
    * \returns number of segments that have been transmitted more than once, without acknowledgment
    */
-  uint32_t GetRetransmitsCount (void) const { return m_retrans; }
+  uint32_t GetRetransmitsCount (void) const;
 
   /**
    * \brief Get the number of segments that we believe are lost in the network
@@ -233,13 +201,13 @@
    * It is calculated in UpdateLostCount.
    * \return the number of lost segment
    */
-  uint32_t GetLost (void) const { return m_lostOut; }
+  uint32_t GetLost (void) const;
 
   /**
    * \brief Get the number of segments that have been explicitly sacked by the receiver.
    * \return the number of sacked segment.
    */
-  uint32_t GetSacked (void) const { return m_sackedOut; }
+  uint32_t GetSacked (void) const;
 
   /**
    * \brief Append a data packet to the end of the buffer
@@ -274,9 +242,10 @@
    *
    * \param numBytes number of bytes to copy
    * \param seq start sequence number to extract
-   * \returns a packet
+   * \returns a pointer to the TcpTxItem that corresponds to what requested.
+   * Please do not delete the pointer, nor modify Packet data or sequence numbers.
    */
-  Ptr<Packet> CopyFromSequence (uint32_t numBytes, const SequenceNumber32& seq);
+  TcpTxItem* CopyFromSequence (uint32_t numBytes, const SequenceNumber32& seq);
 
   /**
    * \brief Set the head sequence of the buffer
@@ -292,15 +261,21 @@
    *
    * \param seq The first sequence number to maintain after discarding all the
    * previous sequences.
+   * \param beforeDelCb Callback invoked, if it is not null, before the deletion
+   * of an Item (because it was, probably, ACKed)
    */
-  void DiscardUpTo (const SequenceNumber32& seq);
+  void DiscardUpTo (const SequenceNumber32& seq,
+                    const Callback<void, TcpTxItem *> &beforeDelCb = m_nullCb);
 
   /**
    * \brief Update the scoreboard
    * \param list list of SACKed blocks
-   * \returns true in case of an update
+   * \param sackedCb Callback invoked, if it is not null, when a segment has been
+   * SACKed by the receiver.
+   * \returns the number of bytes newly sacked by the list of blocks
    */
-  bool Update (const TcpOptionSack::SackList &list);
+  uint32_t Update (const TcpOptionSack::SackList &list,
+                   const Callback<void, TcpTxItem *> &sackedCb = m_nullCb);
 
   /**
    * \brief Check if a segment is lost
@@ -319,10 +294,11 @@
    * \brief Get the next sequence number to transmit, according to RFC 6675
    *
    * \param seq Next sequence number to transmit, based on the scoreboard information
+   * \param seqHigh Maximum sequence number to transmit, based on SMSS and/or receiver window
    * \param isRecovery true if the socket congestion state is in recovery mode
    * \return true is seq is updated, false otherwise
    */
-  bool NextSeg (SequenceNumber32 *seq, bool isRecovery) const;
+  bool NextSeg (SequenceNumber32 *seq, SequenceNumber32 *seqHigh, bool isRecovery) const;
 
   /**
    * \brief Return total bytes in flight
@@ -406,6 +382,12 @@
    */
   void ResetRenoSack ();
 
+  /**
+   * \brief Set callback to obtain receiver window value
+   * \param rWndCallback receiver window callback
+   */
+  void SetRWndCallback (Callback<uint32_t> rWndCallback);
+
 private:
   friend std::ostream & operator<< (std::ostream & os, TcpTxBuffer const & tcpTxBuf);
 
@@ -604,6 +586,7 @@
   uint32_t m_maxBuffer;  //!< Max number of data bytes in buffer (SND.WND)
   uint32_t m_size;       //!< Size of all data in this buffer
   uint32_t m_sentSize;   //!< Size of sent (and not discarded) segments
+  Callback<uint32_t> m_rWndCallback; //!< Callback to obtain RCV.WND value
 
   TracedValue<SequenceNumber32> m_firstByteSeq; //!< Sequence number of the first byte in data (SND.UNA)
   std::pair <PacketList::const_iterator, SequenceNumber32> m_highestSack; //!< Highest SACK byte
@@ -616,6 +599,7 @@
   uint32_t m_segmentSize {0}; //!< Segment size from TcpSocketBase
   bool     m_renoSack {false}; //!< Indicates if AddRenoSack was called
 
+  static Callback<void, TcpTxItem *> m_nullCb; //!< Null callback for an item
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-tx-item.cc ns-3.31/src/internet/model/tcp-tx-item.cc
--- ns-3.30.1/src/internet/model/tcp-tx-item.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/internet/model/tcp-tx-item.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,104 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+#include "tcp-tx-item.h"
+
+namespace ns3 {
+
+void
+TcpTxItem::Print (std::ostream &os) const
+{
+  bool comma = false;
+  os << "[" << m_startSeq << ";" << m_startSeq + GetSeqSize () << "|"
+     << GetSeqSize () << "]";
+
+  if (m_lost)
+    {
+      os << "[lost]";
+      comma = true;
+    }
+  if (m_retrans)
+    {
+      if (comma)
+        {
+          os << ",";
+        }
+
+      os << "[retrans]";
+      comma = true;
+    }
+  if (m_sacked)
+    {
+      if (comma)
+        {
+          os << ",";
+        }
+      os << "[sacked]";
+      comma = true;
+    }
+  if (comma)
+    {
+      os << ",";
+    }
+  os << "[" << m_lastSent.GetSeconds () << "]";
+}
+
+uint32_t
+TcpTxItem::GetSeqSize (void) const
+{
+  return m_packet && m_packet->GetSize () > 0 ? m_packet->GetSize () : 1;
+}
+
+bool
+TcpTxItem::IsSacked (void) const
+{
+  return m_sacked;
+}
+
+bool
+TcpTxItem::IsRetrans (void) const
+{
+  return m_retrans;
+}
+
+Ptr<Packet>
+TcpTxItem::GetPacketCopy (void) const
+{
+  return m_packet->Copy ();
+}
+
+Ptr<const Packet>
+TcpTxItem::GetPacket (void) const
+{
+  return m_packet;
+}
+
+const Time &
+TcpTxItem::GetLastSent (void) const
+{
+  return m_lastSent;
+}
+
+TcpTxItem::RateInformation &
+TcpTxItem::GetRateInformation (void)
+{
+  return m_rateInfo;
+}
+
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-tx-item.h ns-3.31/src/internet/model/tcp-tx-item.h
--- ns-3.30.1/src/internet/model/tcp-tx-item.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/internet/model/tcp-tx-item.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,118 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+#ifndef TCP_TX_ITEM_H
+#define TCP_TX_ITEM_H
+
+#include "ns3/packet.h"
+#include "ns3/nstime.h"
+#include "ns3/sequence-number.h"
+
+namespace ns3 {
+/**
+ * \ingroup tcp
+ *
+ * \brief Item that encloses the application packet and some flags for it
+ */
+class TcpTxItem
+{
+public:
+  // Default constructor, copy-constructor, destructor
+
+  /**
+   * \brief Print the time
+   * \param os ostream
+   */
+  void Print (std::ostream &os) const;
+
+  /**
+   * \brief Get the size in the sequence number space
+   *
+   * \return 1 if the packet size is 0 or there's no packet, otherwise the size of the packet
+   */
+  uint32_t GetSeqSize (void) const;
+
+  /**
+   * \brief Is the item sacked?
+   * \return true if the item is sacked, false otherwise
+   */
+  bool IsSacked (void) const;
+
+  /**
+   * \brief Is the item retransmitted?
+   * \return true if the item have been retransmitted
+   */
+  bool IsRetrans (void) const;
+
+  /**
+   * \brief Get a copy of the Packet underlying this item
+   * \return a copy of the Packet
+   */
+  Ptr<Packet> GetPacketCopy (void) const;
+
+  /**
+   * \brief Get the Packet underlying this item
+   * \return a pointer to a const Packet
+   */
+  Ptr<const Packet> GetPacket (void) const;
+
+  /**
+   * \brief Get a reference to the time the packet was sent for the last time
+   * \return a reference to the last sent time
+   */
+  const Time & GetLastSent (void) const;
+
+  /**
+   * \brief Various rate-related information, can be accessed by TcpRateOps.
+   *
+   * Note: This is not enforced through C++, but you developer must honour
+   * this description.
+   */
+  struct RateInformation
+  {
+    uint64_t m_delivered {0};          //!< Connection's delivered data at the time the packet was sent
+    Time m_deliveredTime {Time::Max ()};//!< Connection's delivered time at the time the packet was sent
+    Time m_firstSent     {Time::Max ()};//!< Connection's first sent time at the time the packet was sent
+    bool m_isAppLimited  {false};      //!< Connection's app limited at the time the packet was sent
+  };
+
+  /**
+   * \brief Get (to modify) the Rate Information of this item
+   *
+   * \return A reference to the rate information.
+   */
+  RateInformation & GetRateInformation (void);
+
+private:
+  // Only TcpTxBuffer is allower to touch this part of the TcpTxItem, to manage
+  // its internal lists and counters
+  friend class TcpTxBuffer;
+
+  SequenceNumber32 m_startSeq {0};   //!< Sequence number of the item (if transmitted)
+  Ptr<Packet> m_packet {nullptr};    //!< Application packet (can be null)
+  bool m_lost          {false};      //!< Indicates if the segment has been lost (RTO)
+  bool m_retrans       {false};      //!< Indicates if the segment is retransmitted
+  Time m_lastSent      {Time::Max ()};//!< Timestamp of the time at which the segment has been sent last time
+  bool m_sacked        {false};      //!< Indicates if the segment has been SACKed
+
+  RateInformation m_rateInfo;        //!< Rate information of the item
+};
+
+} //namespace ns3
+
+#endif /* TCP_TX_ITEM_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-vegas.cc ns-3.31/src/internet/model/tcp-vegas.cc
--- ns-3.30.1/src/internet/model/tcp-vegas.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-vegas.cc	2020-06-27 17:38:30.000000000 -0700
@@ -25,6 +25,8 @@
  */
 
 #include "tcp-vegas.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-vegas.h ns-3.31/src/internet/model/tcp-vegas.h
--- ns-3.30.1/src/internet/model/tcp-vegas.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-vegas.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,11 +27,12 @@
 #ifndef TCPVEGAS_H
 #define TCPVEGAS_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-veno.cc ns-3.31/src/internet/model/tcp-veno.cc
--- ns-3.30.1/src/internet/model/tcp-veno.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-veno.cc	2020-06-27 17:38:30.000000000 -0700
@@ -25,6 +25,8 @@
  */
 
 #include "tcp-veno.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-veno.h ns-3.31/src/internet/model/tcp-veno.h
--- ns-3.30.1/src/internet/model/tcp-veno.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-veno.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,11 +27,12 @@
 #ifndef TCPVENO_H
 #define TCPVENO_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/udp-l4-protocol.cc ns-3.31/src/internet/model/udp-l4-protocol.cc
--- ns-3.30.1/src/internet/model/udp-l4-protocol.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/udp-l4-protocol.cc	2020-06-27 17:38:30.000000000 -0700
@@ -67,12 +67,12 @@
 UdpL4Protocol::UdpL4Protocol ()
   : m_endPoints (new Ipv4EndPointDemux ()), m_endPoints6 (new Ipv6EndPointDemux ())
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 UdpL4Protocol::~UdpL4Protocol ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 void 
@@ -133,7 +133,7 @@
 void
 UdpL4Protocol::DoDispose (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   for (std::vector<Ptr<UdpSocketImpl> >::iterator i = m_sockets.begin (); i != m_sockets.end (); i++)
     {
       *i = 0;
@@ -162,7 +162,7 @@
 Ptr<Socket>
 UdpL4Protocol::CreateSocket (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   Ptr<UdpSocketImpl> socket = CreateObject<UdpSocketImpl> ();
   socket->SetNode (m_node);
   socket->SetUdp (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/udp-socket.cc ns-3.31/src/internet/model/udp-socket.cc
--- ns-3.30.1/src/internet/model/udp-socket.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/udp-socket.cc	2020-06-27 17:38:30.000000000 -0700
@@ -79,12 +79,12 @@
 
 UdpSocket::UdpSocket ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 UdpSocket::~UdpSocket ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/udp-socket-impl.cc ns-3.31/src/internet/model/udp-socket-impl.cc
--- ns-3.30.1/src/internet/model/udp-socket-impl.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/udp-socket-impl.cc	2020-06-27 17:38:30.000000000 -0700
@@ -86,13 +86,13 @@
     m_connected (false),
     m_rxAvailable (0)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_allowBroadcast = false;
 }
 
 UdpSocketImpl::~UdpSocketImpl ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 
   /// \todo  leave any multicast groups that have been joined
   m_node = 0;
@@ -137,14 +137,14 @@
 void 
 UdpSocketImpl::SetNode (Ptr<Node> node)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << node);
   m_node = node;
 
 }
 void 
 UdpSocketImpl::SetUdp (Ptr<UdpL4Protocol> udp)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << udp);
   m_udp = udp;
 }
 
@@ -152,7 +152,7 @@
 enum Socket::SocketErrno
 UdpSocketImpl::GetErrno (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_errno;
 }
 
@@ -165,21 +165,21 @@
 Ptr<Node>
 UdpSocketImpl::GetNode (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_node;
 }
 
 void 
 UdpSocketImpl::Destroy (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_endPoint = 0;
 }
 
 void
 UdpSocketImpl::Destroy6 (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_endPoint6 = 0;
 }
 
@@ -205,7 +205,7 @@
 int
 UdpSocketImpl::FinishBind (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   bool done = false;
   if (m_endPoint != 0)
     {
@@ -231,7 +231,7 @@
 int
 UdpSocketImpl::Bind (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_endPoint = m_udp->Allocate ();
   if (m_boundnetdevice)
     {
@@ -243,7 +243,7 @@
 int
 UdpSocketImpl::Bind6 (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_endPoint6 = m_udp->Allocate6 ();
   if (m_boundnetdevice)
     {
@@ -355,7 +355,7 @@
 int 
 UdpSocketImpl::ShutdownSend (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_shutdownSend = true;
   return 0;
 }
@@ -363,7 +363,7 @@
 int 
 UdpSocketImpl::ShutdownRecv (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   m_shutdownRecv = true;
   if (m_endPoint)
     {
@@ -379,7 +379,7 @@
 int
 UdpSocketImpl::Close (void)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   if (m_shutdownRecv == true && m_shutdownSend == true)
     {
       m_errno = Socket::ERROR_BADF;
@@ -568,15 +568,9 @@
         p->AddPacketTag (tag);
       }
   }
-  //
-  // If dest is set to the limited broadcast address (all ones),
-  // convert it to send a copy of the packet out of every 
-  // interface as a subnet-directed broadcast.
-  // Exception:  if the interface has a /32 address, there is no
-  // valid subnet-directed broadcast, so send it as limited broadcast
-  // Note also that some systems will only send limited broadcast packets
+
+  // Note that some systems will only send limited broadcast packets
   // out of the "default" interface; here we send it out all interfaces
-  //
   if (dest.IsBroadcast ())
     {
       if (!m_allowBroadcast)
@@ -630,6 +624,7 @@
           NS_LOG_LOGIC ("Route exists");
           if (!m_allowBroadcast)
             {
+              // Here we try to route subnet-directed broadcasts
               uint32_t outputIfIndex = ipv4->GetInterfaceForDevice (route->GetOutputDevice ());
               uint32_t ifNAddr = ipv4->GetNAddresses (outputIfIndex);
               for (uint32_t addrI = 0; addrI < ifNAddr; ++addrI)
@@ -796,7 +791,7 @@
 uint32_t
 UdpSocketImpl::GetTxAvailable (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   // No finite send buffer is modelled, but we must respect
   // the maximum size of an IP datagram (65535 bytes - headers).
   return MAX_IPV4_UDP_DATAGRAM_SIZE;
@@ -827,7 +822,7 @@
 uint32_t
 UdpSocketImpl::GetRxAvailable (void) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   // We separately maintain this state to avoid walking the queue 
   // every time this might be called
   return m_rxAvailable;
@@ -872,7 +867,7 @@
 int
 UdpSocketImpl::GetSockName (Address &address) const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this << address);
   if (m_endPoint != 0)
     {
       address = InetSocketAddress (m_endPoint->GetLocalAddress (), m_endPoint->GetLocalPort ());
